---
- name: Add ArcGIS service account to d:\ drive
  ansible.windows.win_acl:
    user: "{{ arcgis_server_service_account['name'] }}"
    path: d:\
    type: allow
    rights: Modify
    state: present
    inherit: ContainerInherit, ObjectInherit

- name: Add ArcGIS service account to install home
  ansible.windows.win_acl:
    user: "{{ arcgis_server_service_account['name'] }}"
    path: "{{ arcgis_server_install['dir'] }}"
    type: allow
    rights: FullControl
    state: present
    inherit: ContainerInherit, ObjectInherit

- name: Create arcgis content folder
  ansible.windows.win_file:
    path: "{{ arcgis_server_install['base'] }}"
    state: directory

- name: Add ArcGIS service account to content dir
  ansible.windows.win_acl:
    user: "{{ arcgis_server_service_account['name'] }}"
    path: "{{ arcgis_server_install['base'] }}"
    type: allow
    rights: FullControl
    state: present
    inherit: ContainerInherit, ObjectInherit

- name: Add ArcGIS service account to user group
  ansible.windows.win_group_membership:
    name: Users
    members:
      - "{{ arcgis_server_service_account['name'] }}"
    state: present

- name: Create ArcGIS Server site
  ansible.windows.win_command: "{{ arcgis_server_install['dir'] }}\\Server\\tools\\createsite\\createsite.bat {{ arcgis_server_create_arguments }}"

- name: Sleep for some time to wait for ArcGIS Server to start
  ansible.builtin.pause:
    minutes: "{{ arcgis_server_for_arcgis_sleep_time }}"
    prompt: Wait for ArcGIS Server to Startup

- name: ArcGIS Server alive check
  ansible.windows.win_uri:
    url: "https://{{ ansible_facts.fqdn }}:6443/arcgis/rest/info/healthCheck?f=json"
    method: GET
    validate_certs: false
    status_code:
      - 200
    return_content: yes
  until: uri_output.status_code == 200
  register: uri_output
  when: arcgis_server_alive_check['enabled'] | default(True)

- name: Set ArcGIS Server initialized fact
  ansible.builtin.set_fact:
    arcgis_server_health_check_status: "{{ uri_output.json.success }}"

- name: The ArcGIS Server is ready for use or federation
  ansible.builtin.debug:
    msg: "The ArcGIS Server is ready for use or federation"
  when: arcgis_server_health_check_status
